//
// Prj002 N1(#258 for Arduino)
//
// 09/04/07
// 	Prj002 node1+
//		CAN, FET, SR-LED
//

//#include <Servo.h>
//#include <Wire.h>
#include <stdio.h>

#include "WProgram.h"
void setup();
void loop();
void SetSR(byte val);
typedef unsigned int word;
//typedef unsigned char BYTE;

#include "CANMsg.h"				// CAN\u30e1\u30c3\u30bb\u30fc\u30b8
#include "CAN2515.h"			// CAN\u30c9\u30e9\u30a4\u30d0

//Servo myservo;  // create servo object to control a servo

// ---------------------
// #258\u7528\u5b9a\u7fa9
// ---------------------

// \u30b7\u30d5\u30c8\u30ec\u30b8\u30b9\u30bf(HC595)\u64cd\u4f5c
#define SR_LAT 12
#define SR_DAT 3
#define SR_CLK 2
#define SR_DAT_1 digitalWrite(SR_DAT, HIGH)
#define SR_DAT_0 digitalWrite(SR_DAT, LOW)
#define SR_LAT_H digitalWrite(SR_LAT, HIGH)
#define SR_LAT_L digitalWrite(SR_LAT, LOW)
#define SR_CLK_H digitalWrite(SR_CLK, HIGH)
#define SR_CLK_L digitalWrite(SR_CLK, LOW)

// \u30b7\u30d5\u30c8\u30ec\u30b8\u30b9\u30bf(HC595) LED\u64cd\u4f5c
#define LED1_ON		SRBuf|=(1<<0);SetSR(SRBuf)
#define LED1_OFF	SRBuf&=~(1<<0);SetSR(SRBuf)
#define LED2_ON		SRBuf|=(1<<1);SetSR(SRBuf)
#define LED2_OFF	SRBuf&=~(1<<1);SetSR(SRBuf)
#define LED3_ON		SRBuf|=(1<<2);SetSR(SRBuf)
#define LED3_OFF	SRBuf&=~(1<<2);SetSR(SRBuf)
#define LED4_ON		SRBuf|=(1<<3);SetSR(SRBuf)
#define LED4_OFF	SRBuf&=~(1<<3);SetSR(SRBuf)
#define LED5_ON		SRBuf|=(1<<4);SetSR(SRBuf)
#define LED5_OFF	SRBuf&=~(1<<4);SetSR(SRBuf)
#define LED6_ON		SRBuf|=(1<<5);SetSR(SRBuf)
#define LED6_OFF	SRBuf&=~(1<<5);SetSR(SRBuf)
#define LED7_ON		SRBuf|=(1<<6);SetSR(SRBuf)
#define LED7_OFF	SRBuf&=~(1<<6);SetSR(SRBuf)
#define LED8_ON		SRBuf|=(1<<7);SetSR(SRBuf)
#define LED8_OFF	SRBuf&=~(1<<7);SetSR(SRBuf)

// FET
#define FET1 6
#define FET2 7
#define FET3 8
#define FET4 11
#define FET1_ON		digitalWrite(FET1, HIGH)
#define FET1_OFF	digitalWrite(FET1, LOW)
#define FET2_ON		digitalWrite(FET2, HIGH)
#define FET2_OFF	digitalWrite(FET2, LOW)
#define FET3_ON		digitalWrite(FET3, HIGH)
#define FET3_OFF	digitalWrite(FET3, LOW)
#define FET4_ON		digitalWrite(FET4, HIGH)
#define FET4_OFF	digitalWrite(FET4, LOW)


byte Flag1Sec = false;

//char StrBuf[16];
byte MsgBuf[14];		// CAN\u9001\u53d7\u4fe1\u30d0\u30c3\u30d5\u30a1 \u30ef\u30fc\u30af

byte SRBuf = 0;			// \u30b7\u30d5\u30c8\u30ec\u30b8\u30b9\u30bf(HC595)\u30d0\u30c3\u30d5\u30a1

byte LoopCnt = 0;
byte LedStat = false;


//
// Arduino\u521d\u671f\u5316
//
void setup()
{
  int i;
  byte dat;

	// \u30b7\u30ea\u30a2\u30ebLED\u7528\u30b7\u30d5\u30c8\u30ec\u30b8\u30b9\u30bf\u521d\u671f\u5316
  pinMode(SR_LAT, OUTPUT);      //
  pinMode(SR_DAT, OUTPUT);      //
  pinMode(SR_CLK, OUTPUT);      //
  SR_LAT_L;
  SetSR(0x00);

	// FET\u30dd\u30fc\u30c8\u521d\u671f\u5316
  pinMode(FET1, OUTPUT);      //
  pinMode(FET2, OUTPUT);      //
  pinMode(FET3, OUTPUT);      //
  pinMode(FET4, OUTPUT);      //
	FET1_OFF;
	FET2_OFF;
	FET3_OFF;
	FET4_OFF;

//	myservo.attach(9);
//	Wire.begin(); // join i2c bus (address optional for master)

	// CAN\u95a2\u4fc2\u306e\u521d\u671f\u5316
	CANInit(CAN_BRP_16MHz_125BPS);			// CLOCK 16MHz CAN 125bps

	CANSetFilterRxB0(3);			// RXB0\u3067\u30d5\u30a3\u30eb\u30bf\u3001\u30de\u30b9\u30af\u306f\u4f7f\u7528\u3057\u306a\u3044
	CANSetFilterRxB1(3);			// RXB1\u3067\u30d5\u30a3\u30eb\u30bf\u3001\u30de\u30b9\u30af\u306f\u4f7f\u7528\u3057\u306a\u3044

	CANSetOpMode(CAM_MODE_NORMAL);	// \u30ce\u30fc\u30de\u30eb\u30fb\u30e2\u30fc\u30c9

	// MCP2515 SPI\u901a\u4fe1\u78ba\u8a8d
	delay(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), 1<<B0BFE);		// LED3 OFF
	delay(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3 ON
  delay(1000);
}


long previousMillis = 0;
long interval = 1000;						// 1000ms

//
// Arduino\u30e1\u30a4\u30f3\u30eb\u30fc\u30d7
//
void loop()
{
	word msg;
	byte ctrl, dlc;

	// 1\u79d2\u5468\u671f\u30bf\u30a4\u30de
  if(millis() - previousMillis > interval) {
    previousMillis = millis();
		Flag1Sec = true;
	}

	if(Flag1Sec) {
		// 1sec\u5468\u671f\u51e6\u7406
		Flag1Sec = false;

		if(LedStat) {
			LED8_ON;
		} else {
			LED8_OFF;
		}
		LedStat = !LedStat;

		switch(LoopCnt) {
			case 0:
				msg = MSG_N2_LED1_ON;
				FET1_ON;
				FET2_OFF;
				FET3_OFF;
				FET4_OFF;
				break;
			case 1:
				msg = MSG_N2_LED1_OFF;
				FET1_OFF;
				FET2_ON;
				FET3_OFF;
				FET4_OFF;
				break;
			case 2:
				msg = MSG_N2_LED2_ON;
				FET1_OFF;
				FET2_OFF;
				FET3_ON;
				FET4_OFF;
				break;
			default:
				msg = MSG_N2_LED2_OFF;
				FET1_OFF;
				FET2_OFF;
				FET3_OFF;
				FET4_ON;
				break;
		}
		LoopCnt = (LoopCnt + 1) % 4;

		// SID
		MsgBuf[1] = GET_SIDH(msg);		// SIDH
		MsgBuf[2] = GET_SIDL(msg);		// SIDL
		MsgBuf[3] = 0;								// EID8
		MsgBuf[4] = 0;								// EID0

		// DLC
		dlc = 0;
		MsgBuf[5] = dlc;
		CANTxB0MsgWrite(&MsgBuf[1]);	// SPI\u30b3\u30de\u30f3\u30c9

		// \u9001\u4fe1\u958b\u59cb
		ctrl = 1<<TXREQ;							// \u9001\u4fe1\u8981\u6c42
		CANWriteReg(TXB0CTRL, ctrl);	// SPI\u30b3\u30de\u30f3\u30c9
	}

	// \u30c7\u30fc\u30bf\u53d7\u4fe1\u30c1\u30a7\u30c3\u30af
	if(CANRxCheck(0)) {			// \u53d7\u4fe1\u30c1\u30a7\u30c3\u30af
		// \u53d7\u4fe1\u3042\u308a

		MsgBuf[0] = CANReadReg(RXB0CTRL);
		CANRxB0Read(&MsgBuf[1], 0);
		msg = MAKE_SID(MsgBuf[1], MsgBuf[2]);
		// msg = (word)MsgBuf[1] << 8;		// SIDH
		// msg |= MsgBuf[2];				// SIDL
		// msg >>= 5;
		// \u53d7\u4fe1\u30e1\u30c3\u30bb\u30fc\u30b8\u5224\u5b9a
		switch(msg) {
			case MSG_N1_LED1_ON:
				LED1_ON;
				break;
			case MSG_N1_LED1_OFF:
				LED1_OFF;
				break;
			case MSG_N1_LED2_ON:
				LED2_ON;
				break;
			case MSG_N1_LED2_OFF:
				LED2_OFF;
				break;
		}
	}
}


//
// \u30b7\u30d5\u30c8\u30ec\u30b8\u30b9\u30bf(HC595)\u51fa\u529b\u8a2d\u5b9a
//
void SetSR(byte val) {
  byte i;

  SRBuf = val;
  for(i = 0; i < 8; i++) {
    if((val & 0x80) != 0) {
      SR_DAT_1;
    } else {
      SR_DAT_0;
    }
    val <<= 1;
    SR_CLK_H;
    SR_CLK_L;
  }
  SR_LAT_H;
  SR_LAT_L;
}


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

